package trz.gaia;

/**
Evento legato al cambiamento di stato di una cellula. Con stato si intende solamente
il numero di connessioni che ha aperte e se fa parte o meno di gaia. 
*/

public class CellulaChangedEvent {

	public final static int APERTA_CON = 0;
	public final static int CHIUSA_CON = 1;
	public final static int ENTRATA = 2;
	public final static int USCITA = 3;
	public final static int CRASH = 4;
	
	//cambio num con, uscita, entrata, crashed
	int tipo = -1;
	
	//numero di connessioni aperte prima di questo evento
	//int prevCon = 0;
	
	//numero di connessioni attualmente aperte
	//int currentCon = 0;

	Cellula cellula = null;

	public CellulaChangedEvent(Cellula cellula, int tipo) {
		this.cellula = cellula;
		//this.descrizione = descrizione;
		this.tipo = tipo;
	}

	public int getTipo() {
		return tipo;
	}
	
	public Cellula getCellula() {
		return cellula;
	}
	
	/*public String getDescrizione() {
		return descrizione;
	}*/
	
	public String toString() {
		return cellula + " [" + tipo;
	}
}



