package trz.gaia;

import java.util.*;
import java.io.*;

/**
Rappresenta una connessione dal punto di vista di una sola cellula.
(cioe' la connessione non e' comune tra le due cellule: ognuna ha la propria).
Una connessione non cambia mai le sue estremita'
Permette di spedire e ricevere pacchetti.

<br><br>### Messa giu' in fretta, rivedere meglio
*/

public interface Connessione {

	/**
	Il nome dell' estremita' di partenza
	*/
	public String getNomeFrom();

	/**
	Il nome dell' estremita' di arrivo
	*/
	public String getNomeTo();

	/**
	Chiude la connessione
	*/
	public void close();

	/**
	Costruisce un pacchetto con quei dati e lo spedisce su questa connessione
	*/
	public void write(String dati) throws IOException;
	
	//spedisce il pacchetto
	public void write(Packet pckt) throws IOException;

	/**
	Legge un pacchetto dalla connessione. Ritorna null se non ci sono pacchetti
	*/	
	public Packet read();

	/**
	Aggiunge un pacchetto nella coda di questa connessione
	###rivedere
	*/
	public void putPacket(Packet pckt);
}
