package trz.gaia.view;

import java.awt.*;
import java.awt.event.*;

import trz.gaia.*;
import trz.gaia.rna.*;
import trz.gaia.util.*;

public class TestView implements TickListener, PacketListener, CellulaChangedListener {

	MultiThreadGaia gaia = new MultiThreadGaia();
	GaiaView view = new GaiaView(gaia);
	
	public static void main(String[] args) throws Exception {
	
		TestView t = new TestView();
		t.esegui();
	}

	public void esegui() throws Exception {
		
		view.setSize(500, 500);
		view.show();
		
		view.addWindowListener(
			new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			}
		);
		
		gaia.addTickListener(this);

		addCellule(1, "A");
		addCellule(1, "B");
		addCellule(1, "C");
		
		gaia.avvia();
	}
	
	public void addCellule(int numero, String gruppo) {
		
		for (int i = 0; i < numero; i++) {
		
			CellulaTest c = new CellulaTest(gruppo + i);
			gaia.addCellula(c, gruppo);
			
			view.addCellula(new CellulaView(c));
			
			ListaCellule.put(c);
			c.addCellulaChangedListener(this);
			c.addPacketListener(this);
		}
	}
	
	public void packetSent(PacketEvent e){
		System.out.println("packet sent " + e + " - " + e.getPacket().getDati());
	}
	public void packetReceived(PacketEvent e){
		System.out.println("packet received " + e + " - " + e.getPacket().getDati());
	}
	public void packetDiscarded(PacketEvent e){}

	public void cellulaChanged(CellulaChangedEvent e){
		System.out.println("cellula changed " + e + " - " 
							+ (e.getTipo() == CellulaChangedEvent.APERTA_CON ? "aperta":"chiusa"));
	}
	public void cellulaEntered(CellulaChangedEvent e){}
	public void cellulaExited(CellulaChangedEvent e){}
	public void cellulaCrashed(CellulaChangedEvent e){}

	public void tickEvent(TickEvent e){
		
		int tc = e.getTickCount();
		if (tc % 1000 == 0)
			System.out.println(tc);
	}

}
