package trz.gaia.rna;

import trz.gaia.*;
import trz.gaia.util.*;
import java.util.*;
import java.io.*;

/**
Classe di test
*/


//### sistemare meglio le exception

public class CellulaBase extends AbstractCellula {

	//il numero di connessioni di una cellula stabile
	final static int N = 3;

	//costanti della accept
	final static int ACCETTA_OK = 0;	//ok
	final static int ACCETTA_ERRATA = -1;	//la connessione e' doppia o simile
	final static int ACCETTA_TROPPE = -2;	//raggiunto numero N di con
	final static int ACCETTA_UNDEF = -10;

	Object mutexListaCon = new Object();
	
	TimeOutSemaforo semaforoCon = new TimeOutSemaforo();
	
	//Connessione[] con = new Connessione[N];
	Vector listaCon = new Vector();
	
	LinkLayer link = LinkLayer.getInstance();
	
	/**
	Apre una con con la cellula specificata
	*/
	public CellulaBase(String nome) {
		setNome(nome);
		link.connetti(this);
	}

	/**
	Gestisce l' apertura di una nuova connessione. Ritorna un numero >= 0 se ok,
	minore altrimenti.
	*/
	//chiamata dall' altro thread
	public int accetta(Connessione con) {
		
		//gestire la condizione dove la cellula non partecipa a gaia
		
		semaforoCon.timeGet();
		
		int exit = ACCETTA_UNDEF;
		synchronized(mutexListaCon) {
		
			boolean ok = true;
			for (int i = 0 ; i < listaCon.size(); i++)
				ok &= !((Connessione)listaCon.elementAt(i)).getNomeTo().equals(con.getNomeTo());
	
			if (listaCon.size() < N && ok) {

				listaCon.add(con);
				//TEMP TEMP
				((AbstractConnessione)con).setPacketListener(pcktListener);
				
				if (listaCon.size() == N)
					System.out.println(getNome() + ": ################## ok " + listaCon);
				exit = ACCETTA_OK;	//ok
				CellulaChangedEvent e = new CellulaChangedEvent(this, CellulaChangedEvent.APERTA_CON);
				notifyCellulaChangedListener(e);
			}
			else {
				if (ok)
					exit = ACCETTA_TROPPE;	//gia raggiunto il massimo
				else
					exit = ACCETTA_ERRATA;	//connessione doppia o strana
			}
		}//fine lock
		semaforoCon.free();
		return exit;
	}

	/**
	Il metodo che viene chiamato ad ogni tick
	*/
	public void esegui() {
	}

	/**
	Apre una connessione con la cellula passata
	
	true se tutto ok, false se non e' riuscito a prendere il secondo lock entro il timeout,
	un exception se ci sono problemi
	*/
	public void apriConnessione(String nomeTo) {

		//System.out.println(getNome() + ": apro connessione con " + nomeTo);
		Connessione con = link.getConnessione(this, nomeTo);
		if (con != null)
			System.out.println(getNome() + ": cell aperta connessione con " + nomeTo);
				
		synchronized(mutexListaCon) {
			if (con != null) {
				
				listaCon.add(con);
				//TEMP TEMP: rivedere meglio
				((AbstractConnessione)con).setPacketListener(pcktListener);
		
				CellulaChangedEvent e = new CellulaChangedEvent(this, CellulaChangedEvent.APERTA_CON);
				notifyCellulaChangedListener(e);
			}
		}//fine lock
	}
	
	protected void chiudiConnessione(int numero) {
		synchronized(mutexListaCon) {
			Connessione con = (Connessione)listaCon.elementAt(numero);
			listaCon.removeElementAt(numero);
			con.close();
		}//fine lock
		CellulaChangedEvent e = new CellulaChangedEvent(this, CellulaChangedEvent.CHIUSA_CON);
		notifyCellulaChangedListener(e);
	}

	/**
	Chiude la connessione con la cellula passata
	*/
	public void chiudiConnessione(String nomeTo) {

		synchronized(mutexListaCon) {
			for (int i = 0; i < listaCon.size(); i++) {
				Connessione con = (Connessione)listaCon.elementAt(i);
				if (con.getNomeTo().equals(nomeTo)) {
					chiudiConnessione(i);
					break;
				}
			}
		}//fine lock
	}

	/**
	Esce da gaia senza chiudere le connessioni
	*/
	public void crash() {
		//implementare
	}
	
	/**
	Entra in gaia (tenta di aprire le connessioni, ecc.).
	*/
	public void entra() {
		//implementare
	}
	
	/**
	Esce "gentilmente" da gaia
	*/
	public void esci() {
		//implementare
	}

	/**
	Spedisce il packet al destinatario
	*/
	public void sendPacket(Packet pckt) {
		//implementare
	}

	//GESTIONE ASCOLTATORI
	protected void notifyRouteListener(RouteEvent e) {
		//###differenziare 	questo metodo in base ai metodi dell' interfaccia listener
		for (int i = 0; i < routeListener.size(); i++)
			((RouteListener)routeListener.elementAt(i)).cellulaReached(e);
	}
	
	public String toString(){
		return getNome() + ":" + listaCon; 
	}	
} 
