package trz.gaia.rna;

import trz.gaia.*;
import java.util.*;

/**
Gestisce la simulazione con piu' thread.<br>
In questo modo la gestione dei tick non ha piu' senso e quindi genera
un exception.<br>
Le cellule di uno stesso gruppo sono gestite da uno stesso thread.
*/

public class MultiThreadGaia extends Gaia {

	/*
	Contiene i nomi dei gruppi come chiave e delle SingleThreadGaia come valori
	*/
	Hashtable gruppi = new Hashtable();

	public void addCellula(Cellula cellula){
	
		//oppure aggiungerlo ad un gruppo di default ?
		throw new UnsupportedOperationException("Metodo addCellula(Cellula) non supportato");
	}
	
	public void addCellula(Cellula cellula, String nomeGruppo) {
		
		SingleThreadGaia gruppo = (SingleThreadGaia)gruppi.get(nomeGruppo);
		if (gruppo == null) {
			gruppo = new SingleThreadGaia();
			gruppi.put(nomeGruppo, gruppo);
			System.out.println("Creato nuovo gruppo: " + nomeGruppo);
		}
		gruppo.addCellula(cellula);
	}
	
	public void removeCellula(Cellula cellula){
		throw new UnsupportedOperationException("Questo e' da fare");
	}

	public void reset(){
		
		blocca();
		gruppi.clear();
	}
	
	public void avvia() {
		//### controllare se il runner e' stato bloccato e crearne un nuovo 
		//System.out.println("avvia");
		Iterator iterGruppi = gruppi.values().iterator();
		while (iterGruppi.hasNext())
			((SingleThreadGaia)iterGruppi.next()).avvia();
		//###notificare
	}

	/**
	Blocca definitivamente la simulazione
	*/
	public void blocca() {
		//System.out.println("stop");
		Iterator iterGruppi = gruppi.values().iterator();
		while (iterGruppi.hasNext())
			((SingleThreadGaia)iterGruppi.next()).blocca();
		//###notificare
	}
	
	/**
	Sospende la simulazione
	*/
	public void pausa() {
		//System.out.println("pausa");
		Iterator iterGruppi = gruppi.values().iterator();
		while (iterGruppi.hasNext())
			((SingleThreadGaia)iterGruppi.next()).pausa();
		//###notificare
	}

	/**
	Fa ripartire la simulazione (non fa nulla se la simulazione non e' mai partita)
	*/
	public void riparti() {
		//System.out.println("riparti");
		Iterator iterGruppi = gruppi.values().iterator();
		while (iterGruppi.hasNext())
			((SingleThreadGaia)iterGruppi.next()).riparti();
		//###notificare
	}

	/**
	Non ha senso, genera exception
	*/
	protected void main(){
		throw new UnsupportedOperationException("Metodo esegui() non supportato");
	}

	/**
	Non ha senso, genera exception
	*/
	public void tick() {
		throw new UnsupportedOperationException("Metodo tick() non supportato");
	}
} 
