package trz.gaia.rna;

import trz.gaia.*;
import java.util.*;

/**
Aggiunge la possibilita' di far girare la simulazione in modo asincrono.<br>
Tutte le cellule sono gestite da un unico thread.
*/

public class SingleThreadGaia extends Gaia {

	Vector cellule = new Vector();
	
	GaiaRunner runner = null;

	public SingleThreadGaia() {
		runner = new GaiaRunner(this);
	}

	//chiama la esegui di ogni singola cellula
	protected void main() {
		//pausare un po' il for ?
		for (int i = 0; i < cellule.size(); i++)
			((Cellula)cellule.elementAt(i)).esegui();
	}

	public void addCellula(Cellula cellula){
		cellule.add(cellula);
	}
	
	public void addCellula(Cellula cellula, String nomeGruppo) {
		throw new UnsupportedOperationException("Metodo non supportato dalla classe SingleThreadGaia");
	}
	
	public void removeCellula(Cellula cellula){
		cellule.remove(cellula);
	}
	
	public void reset(){
		blocca();
		cellule = new Vector();
		resetTickCount();
	}
	
	public void avvia() {
		//### controllare se il runner e' stato bloccato e crearne un nuovo 
		//System.out.println("avvia");
		if (runner == null)
			runner = new GaiaRunner(this);
		runner.start();
		//###notificare
	}

	/**
	Blocca definitivamente la simulazione
	*/
	/*
	Vedere di non utilizzare direttamente GaiaRunnable come thread, ma di crearne uno interno
	in modo da poter stoppare e ripartire.
	*/
	public void blocca() {
		//System.out.println("stop");
		runner.blocca();
		runner = null;
		//###notificare
	}
	
	/**
	Sospende la simulazione
	*/
	public void pausa() {
		//System.out.println("pausa");
		runner.pausa();
		//###notificare
	}

	/**
	Fa ripartire la simulazione (non fa nulla se la simulazione non e' mai partita)
	*/
	public void riparti() {
		//System.out.println("riparti");
		runner.riparti();
		//###notificare
	}

	//per rallentare la simulazione
	long pausa = 50;

	//inner class
	class GaiaRunner extends Thread {

		boolean attivo = true;
		boolean running = true;

		Gaia gaia = null;
		
		public GaiaRunner(Gaia gaia) {
			this.gaia = gaia;
		}
		
		public void run() {
		
			while(attivo) {
				while(running) {
					gaia.tick();
					try {Thread.sleep(5L+pausa);}catch(InterruptedException e){}
					yield();
				}
				//mettere uno sleep per alleggerire ?
				yield();
				//try {Thread.sleep(5);}catch(InterruptedException e){}
			}
		}
		
		//private boolean isRunning(){return running;}
		//private boolean isAttivo(){return attivo;}
			
		public void pausa() {
			running = false;
		}
		public void riparti() {
			running = true;
		}
		public void blocca() {
			running = false;
			attivo = false;
		}
	} //fine inner class GaiaRunner
} 
