package trz.gaia.rna;

import trz.gaia.*;
import trz.gaia.rna.*;
import trz.gaia.util.*;

public class Test implements TickListener, PacketListener, CellulaChangedListener {

	MultiThreadGaia gaia = new MultiThreadGaia();
	
	public static void main(String[] args) throws Exception {
	
		Test t = new Test();
		t.esegui();
	}

	public void esegui() throws Exception {
		
		gaia.addTickListener(this);

		addCellule(1, "A");
		addCellule(1, "B");
		addCellule(1, "C");
		
		addCellule(10, "D");
		addCellule(10, "E");
		addCellule(10, "F");
		/*
		addCellule(1, "G");
		addCellule(1, "H");
		addCellule(1, "I");

		addCellule(1, "L");
		addCellule(1, "M");
		addCellule(1, "N");

		addCellule(1, "O");
		addCellule(1, "P");
		addCellule(1, "Q");

		addCellule(1, "R");
		addCellule(1, "S");
		addCellule(1, "T");

		addCellule(1, "U");
		addCellule(1, "V");
		addCellule(1, "Z");
		*/
		
		CellulaTest c = new CellulaTest("_localhost");
		ListaCellule.put(c);
		
		gaia.avvia();
	}
	
	public void addCellule(int numero, String gruppo) {
		
		for (int i = 0; i < numero; i++) {
		
			CellulaTest c = new CellulaTest(gruppo + i);
			gaia.addCellula(c, gruppo);
			ListaCellule.put(c);
			c.addCellulaChangedListener(this);
			c.addPacketListener(this);
		}
	}
	
	public void packetSent(PacketEvent e){
		System.out.println("packet sent " + e + " - " + e.getPacket().getDati());
	}
	public void packetReceived(PacketEvent e){
		System.out.println("packet received " + e + " - " + e.getPacket().getDati());
	}
	public void packetDiscarded(PacketEvent e){}

	public void cellulaChanged(CellulaChangedEvent e){
		System.out.println("cellula changed " + e + " - " 
							+ (e.getTipo() == CellulaChangedEvent.APERTA_CON ? "aperta":"chiusa"));
	}
	public void cellulaEntered(CellulaChangedEvent e){}
	public void cellulaExited(CellulaChangedEvent e){}
	public void cellulaCrashed(CellulaChangedEvent e){}

	public void tickEvent(TickEvent e){
		
		int tc = e.getTickCount();
		if (tc % 1000 == 0)
			System.out.println(tc);
	}

}
